import mediapipe.python.solutions.face_mesh_connections as face_mesh

from enum import Enum

class FaceIndexes(Enum):
    #Connections
    FACEMESH_LIPS_CONNECTIONS = set(face_mesh.FACEMESH_LIPS)

    FACEMESH_LEFT_EYE_CONNECTIONS = set(face_mesh.FACEMESH_LEFT_EYE)
    FACEMESH_RIGHT_EYE_CONNECTIONS = set(face_mesh.FACEMESH_RIGHT_EYE)

    FACEMESH_LEFT_IRIS_CONNECTIONS = set(face_mesh.FACEMESH_LEFT_IRIS)
    FACEMESH_RIGHT_IRIS_CONNECTIONS = set(face_mesh.FACEMESH_RIGHT_IRIS)
    FACEMESH_IRISES_CONNECTIONS = set(face_mesh.FACEMESH_IRISES)

    FACEMESH_LEFT_EYEBROW_CONNECTIONS = set(face_mesh.FACEMESH_LEFT_EYEBROW)
    FACEMESH_RIGHT_EYEBROW_CONNECTIONS = set(face_mesh.FACEMESH_RIGHT_EYEBROW)

    FACEMESH_NOSE_CONNECTIONS = set(face_mesh.FACEMESH_NOSE)

    FACEMESH_FACE_OVAL_CONNECTIONS = set(face_mesh.FACEMESH_FACE_OVAL)
    FACEMESH_CONTOURS_CONNECTIONS = set(face_mesh.FACEMESH_CONTOURS)
    FACEMESH_TESSELATION_CONNECTIONS = set(face_mesh.FACEMESH_TESSELATION)
    
    # Indexes
    FACEMESH_LIPS = tuple(sorted(set().union(*FACEMESH_LIPS_CONNECTIONS)))

    FACEMESH_LEFT_EYE = tuple(sorted(set().union(*FACEMESH_LEFT_EYE_CONNECTIONS)))
    FACEMESH_RIGHT_EYE = tuple(sorted(set().union(*FACEMESH_RIGHT_EYE_CONNECTIONS)))

    FACEMESH_LEFT_IRIS = tuple(sorted(set().union(*FACEMESH_LEFT_IRIS_CONNECTIONS)))
    FACEMESH_RIGHT_IRIS = tuple(sorted(set().union(*FACEMESH_RIGHT_IRIS_CONNECTIONS)))
    FACEMESH_IRISES = tuple(sorted(set().union(*FACEMESH_IRISES_CONNECTIONS)))

    FACEMESH_LEFT_EYEBROW = tuple(sorted(set().union(*FACEMESH_LEFT_EYEBROW_CONNECTIONS)))
    FACEMESH_RIGHT_EYEBROW = tuple(sorted(set().union(*FACEMESH_RIGHT_EYEBROW_CONNECTIONS)))

    FACEMESH_NOSE = tuple(sorted(set().union(*FACEMESH_NOSE_CONNECTIONS)))

    FACEMESH_FACE_OVAL = tuple(sorted(set().union(*FACEMESH_FACE_OVAL_CONNECTIONS)))
    FACEMESH_CONTOURS = tuple(sorted(set().union(*FACEMESH_CONTOURS_CONNECTIONS)))
    FACEMESH_TESSELATION = tuple(sorted(set().union(*FACEMESH_TESSELATION_CONNECTIONS)))